> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Batch Create Expected Machines

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/expected-machine/batch
Content-Type: application/json

Create multiple Expected Machines in a single request. All machines must belong to the same site.

Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` role.

Alternatively, Tenant Admins with `TargetedInstanceCreation` capability can also create Expected Machines if they have an account with the Site's Infrastructure Provider.

Maximum batch size: 100 Expected Machines per request.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/expected-machine/batch-create-expected-machines

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/expected-machine/batch:
    post:
      operationId: batch-create-expected-machines
      summary: Batch Create Expected Machines
      description: >-
        Create multiple Expected Machines in a single request. All machines must
        belong to the same site.


        Org must have an Infrastructure Provider entity. User must have
        `FORGE_PROVIDER_ADMIN` role.


        Alternatively, Tenant Admins with `TargetedInstanceCreation` capability
        can also create Expected Machines if they have an account with the
        Site's Infrastructure Provider.


        Maximum batch size: 100 Expected Machines per request.
      tags:
        - subpackage_expectedMachine
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                type: array
                items:
                  $ref: '#/components/schemas/ExpectedMachine'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        description: Array of Expected Machine creation requests
        content:
          application/json:
            schema:
              type: array
              items:
                $ref: '#/components/schemas/ExpectedMachineCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    ExpectedMachineCreateRequest:
      type: object
      properties:
        siteId:
          type: string
          format: uuid
          description: ID of the site the Expected Machine belongs to
        bmcMacAddress:
          type: string
          description: >-
            MAC address of the Expected Machine's BMC (Baseboard Management
            Controller)
        bmcUsername:
          type:
            - string
            - 'null'
          description: Username for accessing the Expected Machine's BMC
        bmcPassword:
          type:
            - string
            - 'null'
          description: Password for accessing the Expected Machine's BMC
        chassisSerialNumber:
          type: string
          description: Serial number of the Expected Machine's chassis
        fallbackDPUSerialNumbers:
          type:
            - array
            - 'null'
          items:
            type: string
          description: >-
            Serial numbers of the Expected Machine's fallback DPUs (Data
            Processing Units)
        skuId:
          type:
            - string
            - 'null'
          description: Optional ID of the SKU to associate with this Expected Machine
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Machines
      required:
        - siteId
        - bmcMacAddress
        - chassisSerialNumber
      description: >-
        Request data to create a new ExpectedMachine.


        Note: BMC credentials (username/password) are only accepted during
        creation and updates but are not returned in responses.
      title: ExpectedMachineCreateRequest
    SkuCpu:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the CPU
        model:
          type: string
          description: Model of the CPU
        threadCount:
          type: integer
          format: uint
          description: Number of threads for the CPU
        count:
          type: integer
          format: uint
          description: Number of CPUs present
      description: CPU component in a SKU
      title: SkuCpu
    SkuGpu:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the GPU
        model:
          type: string
          description: Model of the GPU
        totalMemory:
          type: string
          description: Total memory of the GPU (e.g. "80GB HBM3")
        count:
          type: integer
          format: uint
          description: Number of GPUs present
      description: GPU component in a SKU
      title: SkuGpu
    SkuMemory:
      type: object
      properties:
        capacityMb:
          type: integer
          format: uint
          description: Capacity in megabytes
        memoryType:
          type: string
          description: Type of memory (e.g. "DDR4", "DDR5")
        count:
          type: integer
          format: uint
          description: Number of memory modules present
      description: Memory component in a SKU
      title: SkuMemory
    SkuStorage:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the storage device
        model:
          type: string
          description: Model of the storage device
        capacityMb:
          type: integer
          format: uint
          description: Capacity in megabytes
        count:
          type: integer
          format: uint
          description: Number of storage devices present
      description: Storage component in a SKU
      title: SkuStorage
    SkuChassis:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the chassis
        model:
          type: string
          description: Model of the chassis
      description: Chassis component in a SKU
      title: SkuChassis
    SkuEthernetDevice:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the ethernet device
        model:
          type: string
          description: Model of the ethernet device
        count:
          type: integer
          format: uint
          description: Number of ethernet devices present
      description: Ethernet device component in a SKU
      title: SkuEthernetDevice
    SkuInfinibandDevice:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the infiniband device
        model:
          type: string
          description: Model of the infiniband device
        count:
          type: integer
          format: uint
          description: Number of infiniband devices present
      description: Infiniband device component in a SKU
      title: SkuInfinibandDevice
    SkuTpm:
      type: object
      properties:
        vendor:
          type: string
          description: Vendor of the TPM
        model:
          type: string
          description: Model of the TPM
        count:
          type: integer
          format: uint
          description: Number of TPMs present
      description: TPM component in a SKU
      title: SkuTpm
    SkuComponents:
      type: object
      properties:
        cpus:
          type: array
          items:
            $ref: '#/components/schemas/SkuCpu'
          description: CPU components
        gpus:
          type: array
          items:
            $ref: '#/components/schemas/SkuGpu'
          description: GPU components
        memory:
          type: array
          items:
            $ref: '#/components/schemas/SkuMemory'
          description: Memory components
        storage:
          type: array
          items:
            $ref: '#/components/schemas/SkuStorage'
          description: Storage components
        chassis:
          $ref: '#/components/schemas/SkuChassis'
          description: Chassis component
        ethernetDevices:
          type: array
          items:
            $ref: '#/components/schemas/SkuEthernetDevice'
          description: Ethernet device components
        infinibandDevices:
          type: array
          items:
            $ref: '#/components/schemas/SkuInfinibandDevice'
          description: Infiniband device components
        tpm:
          type: array
          items:
            $ref: '#/components/schemas/SkuTpm'
          description: TPM components
      description: Hardware components that make up a SKU
      title: SkuComponents
    Sku:
      type: object
      properties:
        id:
          type: string
          description: Unique identifier for the SKU
        siteId:
          type: string
          format: uuid
          description: ID of the Site this SKU belongs to
        deviceType:
          type:
            - string
            - 'null'
          description: Optional device type identifier (e.g. "gpu", "cpu", "storage")
        associatedMachineIds:
          type: array
          items:
            type: string
          description: List of machine IDs associated with this SKU
        components:
          $ref: '#/components/schemas/SkuComponents'
          description: Hardware components of this SKU
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the SKU was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the SKU was last updated
      description: >-
        A SKU (Stock Keeping Unit) represents a unique hardware configuration
        discovered at a site.

        SKUs are automatically derived from machine hardware characteristics and
        used to group similar machines.
      title: Sku
    MachineStatus:
      type: string
      enum:
        - Initializing
        - Ready
        - Reset
        - Maintenance
        - InUse
        - Error
        - Decommissioned
        - Unknown
      description: Status values for Machine objects
      title: MachineStatus
    MachineSummary:
      type: object
      properties:
        id:
          type: string
          description: Unique ID of Machine
        controllerMachineId:
          type: string
          description: ID of the Machine at Site, now same as the primary ID
        controllerMachineType:
          type:
            - string
            - 'null'
          description: Denotes architecture (x86 vs ARM) of the Machine
        hwSkuDeviceType:
          type:
            - string
            - 'null'
          description: >-
            SKU derived device type of the machine, e.g. cpu, gpu, cache,
            storage, etc.
        vendor:
          type:
            - string
            - 'null'
          description: Name of the vendor of the Machine
        productName:
          type:
            - string
            - 'null'
          description: Product name of the Machine
        maintenanceMessage:
          type:
            - string
            - 'null'
          description: >-
            If the Machine is in maintenance mode, this message will typically
            describe the reason and how long it is expected to be in maintenance
        status:
          $ref: '#/components/schemas/MachineStatus'
      description: Describes a subset of core attributes for a Machine
      title: MachineSummary
    ExpectedMachine:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the Expected Machine
        siteId:
          type: string
          format: uuid
          description: ID of the site the Expected Machine belongs to
        bmcMacAddress:
          type: string
          description: >-
            MAC address of the Expected Machine's BMC (Baseboard Management
            Controller)
        chassisSerialNumber:
          type: string
          description: Serial number of the Expected Machine's chassis
        fallbackDPUSerialNumbers:
          type: array
          items:
            type: string
          description: >-
            Serial numbers of the Expected Machine's fallback DPUs (Data
            Processing Units)
        skuId:
          type:
            - string
            - 'null'
          description: Optional ID of the SKU associated with this Expected Machine
        sku:
          $ref: '#/components/schemas/Sku'
          description: >-
            SKU information for this Expected Machine (populated when
            includeRelation=Sku is specified)
        machineId:
          type:
            - string
            - 'null'
          description: Optional ID of the Machine associated with this Expected Machine
        machine:
          $ref: '#/components/schemas/MachineSummary'
          description: >-
            Machine information for this Expected Machine (populated when
            includeRelation=Machine is specified)
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Machines
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Machine was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Machine was last updated
      description: >-
        An Expected Machine represents a physical machine that is expected to be
        discovered at a site, with hardware identifiers and metadata.


        Note: BMC credentials (username/password) are only accepted during
        creation and updates but are not returned in responses.
      title: ExpectedMachine
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch"

payload = [
    {
        "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
        "bmcMacAddress": "00:1A:2B:3C:4D:5E",
        "chassisSerialNumber": "CHASSIS-12345",
        "bmcUsername": "admin",
        "bmcPassword": "password123",
        "fallbackDPUSerialNumbers": ["DPU-001", "DPU-002"],
        "labels": {
            "environment": "production",
            "rack": "A1"
        }
    },
    {
        "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
        "bmcMacAddress": "00:1A:2B:3C:4D:5F",
        "chassisSerialNumber": "CHASSIS-12346",
        "bmcUsername": "admin",
        "bmcPassword": "password456",
        "fallbackDPUSerialNumbers": ["DPU-003", "DPU-004"],
        "labels": {
            "environment": "production",
            "rack": "A2"
        }
    }
]
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '[{"siteId":"f97df110-f4de-492e-8849-4a6af68026b0","bmcMacAddress":"00:1A:2B:3C:4D:5E","chassisSerialNumber":"CHASSIS-12345","bmcUsername":"admin","bmcPassword":"password123","fallbackDPUSerialNumbers":["DPU-001","DPU-002"],"labels":{"environment":"production","rack":"A1"}},{"siteId":"f97df110-f4de-492e-8849-4a6af68026b0","bmcMacAddress":"00:1A:2B:3C:4D:5F","chassisSerialNumber":"CHASSIS-12346","bmcUsername":"admin","bmcPassword":"password456","fallbackDPUSerialNumbers":["DPU-003","DPU-004"],"labels":{"environment":"production","rack":"A2"}}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch"

	payload := strings.NewReader("[\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n    \"chassisSerialNumber\": \"CHASSIS-12345\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password123\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-001\",\n      \"DPU-002\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A1\"\n    }\n  },\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5F\",\n    \"chassisSerialNumber\": \"CHASSIS-12346\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password456\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-003\",\n      \"DPU-004\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A2\"\n    }\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n    \"chassisSerialNumber\": \"CHASSIS-12345\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password123\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-001\",\n      \"DPU-002\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A1\"\n    }\n  },\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5F\",\n    \"chassisSerialNumber\": \"CHASSIS-12346\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password456\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-003\",\n      \"DPU-004\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A2\"\n    }\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n    \"chassisSerialNumber\": \"CHASSIS-12345\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password123\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-001\",\n      \"DPU-002\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A1\"\n    }\n  },\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5F\",\n    \"chassisSerialNumber\": \"CHASSIS-12346\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password456\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-003\",\n      \"DPU-004\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A2\"\n    }\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch', [
  'body' => '[
  {
    "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
    "bmcMacAddress": "00:1A:2B:3C:4D:5E",
    "chassisSerialNumber": "CHASSIS-12345",
    "bmcUsername": "admin",
    "bmcPassword": "password123",
    "fallbackDPUSerialNumbers": [
      "DPU-001",
      "DPU-002"
    ],
    "labels": {
      "environment": "production",
      "rack": "A1"
    }
  },
  {
    "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
    "bmcMacAddress": "00:1A:2B:3C:4D:5F",
    "chassisSerialNumber": "CHASSIS-12346",
    "bmcUsername": "admin",
    "bmcPassword": "password456",
    "fallbackDPUSerialNumbers": [
      "DPU-003",
      "DPU-004"
    ],
    "labels": {
      "environment": "production",
      "rack": "A2"
    }
  }
]',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n    \"chassisSerialNumber\": \"CHASSIS-12345\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password123\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-001\",\n      \"DPU-002\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A1\"\n    }\n  },\n  {\n    \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n    \"bmcMacAddress\": \"00:1A:2B:3C:4D:5F\",\n    \"chassisSerialNumber\": \"CHASSIS-12346\",\n    \"bmcUsername\": \"admin\",\n    \"bmcPassword\": \"password456\",\n    \"fallbackDPUSerialNumbers\": [\n      \"DPU-003\",\n      \"DPU-004\"\n    ],\n    \"labels\": {\n      \"environment\": \"production\",\n      \"rack\": \"A2\"\n    }\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
    "bmcMacAddress": "00:1A:2B:3C:4D:5E",
    "chassisSerialNumber": "CHASSIS-12345",
    "bmcUsername": "admin",
    "bmcPassword": "password123",
    "fallbackDPUSerialNumbers": ["DPU-001", "DPU-002"],
    "labels": [
      "environment": "production",
      "rack": "A1"
    ]
  ],
  [
    "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
    "bmcMacAddress": "00:1A:2B:3C:4D:5F",
    "chassisSerialNumber": "CHASSIS-12346",
    "bmcUsername": "admin",
    "bmcPassword": "password456",
    "fallbackDPUSerialNumbers": ["DPU-003", "DPU-004"],
    "labels": [
      "environment": "production",
      "rack": "A2"
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-machine/batch")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```